setwd("C:/Users/Batagelj/work/clamix/clamix.R")
source("C:\\Users\\Batagelj\\work\\clamix\\clamix.R\\cars\\encCars.R")
source("C:\\Users\\Batagelj\\work\\clamix\\clamix.R\\clamix.R")
cf <- read.table("./cars/cars.csv",header=TRUE,dec=".",row.names=1)
numSO <- nrow(cf)
nVar <- ncol(cf); nVarP <- nVar+1

carsSO <- vector("list",nVar)
names(carsSO) <- colnames(cf)
carsCats <- vector("list",nVar)
names(carsCats) <- colnames(cf)

carsCats$price <- names(encPrice)
carsSO$price <- sapply(cf$price,function(x) encodeSO(x,encPrice,7))

carsCats$type <- c(levType,NA)
carsSO$type <- as.integer(factor(cf$type,levels=levType))

carsCats$NumDoors <- namesNumDoors
carsSO$NumDoors <- sapply(cf$NumDoors,codeNumDoors)

carsCats$NumPassen <- namesNumPassen
carsSO$NumPassen <- sapply(cf$NumPassen,codeNumPassen)

carsCats$motorsite <- c(levMsite,NA)
carsSO$motorsite <- as.integer(factor(cf$motorsite,levels=levMsite))

carsCats$drive <- c(levDrive,NA)
carsSO$drive <- as.integer(factor(cf$drive,levels=levDrive))

carsCats$length <- names(encLen)
carsSO$length <- sapply(cf$length,function(x) encodeSO(x,encLen,7))

carsCats$width <- names(encWid)
carsSO$width <- sapply(cf$width,function(x) encodeSO(x,encWid,7))

carsCats$height <- names(encHei)
carsSO$height <- sapply(cf$height,function(x) encodeSO(x,encHei,7))

carsCats$wheelbase <- names(encWba)
carsSO$wheelbase <- sapply(cf$wheelbase,function(x) encodeSO(x,encWba,7))

carsCats$luggage <- names(encLug)
carsSO$luggage <- sapply(cf$luggage,function(x) encodeSO(x,encLug,7))

carsCats$enlarLugg <- c(levELu,NA)
carsSO$enlarLugg <- as.integer(factor(cf$enlarLugg,levels=levELu))

carsCats$fuelCapac <- names(encFCa)
carsSO$fuelCapac <- sapply(cf$fuelCapac,function(x) encodeSO(x,encFCa,7))

carsCats$weight <- names(encWei)
carsSO$weight <- sapply(cf$weight,function(x) encodeSO(x,encWei,7))

carsCats$maxLoad <- names(encMlo)
carsSO$maxLoad <- sapply(cf$maxLoad,function(x) encodeSO(x,encMlo,7))

carsCats$displace <- names(encDsp)
carsSO$displace <- sapply(cf$displace,function(x) encodeSO(x,encDsp,7))

carsCats$maxPowKW <- names(encMkw)
carsSO$maxPowKW <- sapply(cf$maxPowKW,function(x) encodeSO(x,encMkw,7))

carsCats$maxPowKM <- names(encMkm)
carsSO$maxPowKM <- sapply(cf$maxPowKM,function(x) encodeSO(x,encMkm,7))

carsCats$rpm_maxPow <- names(encRMp)
carsSO$rpm_maxPow <- sapply(cf$rpm_maxPow,function(x) encodeSO(x,encRMp,7))

carsCats$maxTorque <- names(encMtq)
carsSO$maxTorque <- sapply(cf$maxTorque,function(x) encodeSO(x,encMtq,7))

carsCats$rpm_maxTor <- names(encRMt)
carsSO$rpm_maxTor <- sapply(cf$rpm_maxTor,function(x) encodeSO(x,encRMt,7))

carsCats$transmiss <- c(levTrans,NA)
carsSO$transmiss <- as.integer(factor(cf$transmiss,levels=levTrans))

carsCats$breaks <- c(levBreak,NA)
carsSO$breaks <- as.integer(factor(cf$breaks,levels=levBreak))

carsCats$minFuelCon <- names(encFue)
carsSO$minFuelCon <- sapply(cf$minFuelCon,function(x) encodeSO(x,encFue,7))

carsCats$accelTime <- names(encAcc)
carsSO$accelTime <- sapply(cf$accelTime,function(x) encodeSO(x,encAcc,7))

carsCats$maxSpeed <- names(encSpe)
carsSO$maxSpeed <- sapply(cf$maxSpeed,function(x) encodeSO(x,encSpe,7))

save(carsSO,file="./cars/cars.Rdata")
nCats <- as.integer(sapply(carsCats,length))
so <- emptySO(nCats)
# !!! problems with ' in car names;  ' -> "'"  in the file  cars.nam
cn <- read.table("./cars/cars.nam",header=FALSE,sep=";")
long <- as.vector(cn[,2])
namedSO <- so
names(namedSO) <- c(names(carsCats),"num")
for(i in 1:nVar) names(namedSO[[i]]) <- carsCats[[i]]
save(nVar,nVarP,so,namedSO,numSO,long,carsCats,file="./cars/cars.meta")
SOs <- vector("list",numSO)
for(i in 1:numSO){
  st <- so
  for(j in 1:nVar) st[[j]][carsSO[[j]][[i]]] <- 1
  st$num <- 1
  names(SOs)[[i]] <- long[[i]]
  SOs[[i]] <- st
}
save(nVar,nVarP,so,numSO,SOs,file="./cars/cars.so")



